import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
// eslint-disable-next-line spaced-comment, @typescript-eslint/triple-slash-reference
/// <reference path="../../../storybook-static/index.d.ts" />
import { memo, useCallback } from 'react';
import { BodyText, Stack, Button, ButtonGroup, Link, Checkbox, Toast, Frame, Headline, Page, Layout, Card, } from '@servicetitan/design-system';
import { FeaturePopover } from './components/feature-popover';
import { FeatureModal } from './components/feature-modal';
import { FeatureToast } from './components/feature-toast';
import { TourPopover } from './components/tour-popover';
import geofence from '../../../storybook-static/geofence.png';
import dashboard from '../../../storybook-static/dashboard.png';
import { TourProvider, useTour } from '@reactour/tour';
const image = {
    src: geofence,
    alt: 'alt text description',
};
const imageDashboard = {
    src: dashboard,
    alt: 'alt text description',
};
export default {
    title: 'Feature Spotlight/Demos',
};
export const Popover = () => (_jsxs(Stack, { direction: "column", spacing: 5, alignItems: "center", justifyContent: "center", className: "p-4", style: { height: '800px' }, children: [_jsx(FeaturePopover, { trigger: _jsx(Button, { inactive: true, children: "Top" }), open: true, direction: "t", header: "\uD83D\uDC4B Bills has moved", footer: _jsx(ButtonGroup, { children: _jsx(Button, { small: true, primary: true, children: "Take me there" }) }), footerAlign: "right", offset: { distance: 200 }, children: _jsxs(Stack, { spacing: 1, direction: "column", children: [_jsxs(BodyText, { size: "small", children: ["Bills has a new home in Accounting. It is still the same feature you know and love except now something goes here.", _jsx(Link, { primary: true, children: "Learn More" })] }), _jsx(Checkbox, { size: "small", label: "Don\u2019t show me again" })] }) }), _jsx(FeaturePopover, { trigger: _jsx(Button, { inactive: true, children: "Right" }), open: true, direction: "r", header: "\uD83D\uDC4B Bills has moved", footer: _jsx(ButtonGroup, { children: _jsx(Button, { small: true, primary: true, children: "Take me there" }) }), footerAlign: "right", offset: { distance: 200 }, children: _jsxs(Stack, { spacing: 1, direction: "column", children: [_jsxs(BodyText, { size: "small", children: ["Bills has a new home in Accounting. It is still the same feature you know and love except now something goes here.", _jsx(Link, { primary: true, children: "Learn More" })] }), _jsx(Checkbox, { size: "small", label: "Don\u2019t show me again" })] }) }), _jsx(FeaturePopover, { trigger: _jsx(Button, { inactive: true, children: "Left" }), open: true, direction: "l", header: "\uD83D\uDC4B Bills has moved", footer: _jsx(ButtonGroup, { children: _jsx(Button, { small: true, primary: true, children: "Take me there" }) }), footerAlign: "right", offset: { distance: 200 }, children: _jsxs(Stack, { spacing: 1, direction: "column", children: [_jsxs(BodyText, { size: "small", children: ["Bills has a new home in Accounting. It is still the same feature you know and love except now something goes here.", _jsx(Link, { primary: true, children: "Learn More" })] }), _jsx(Checkbox, { size: "small", label: "Don\u2019t show me again" })] }) }), _jsx(FeaturePopover, { trigger: _jsx(Button, { inactive: true, children: "Bottom" }), open: true, direction: "b", header: "\uD83D\uDC4B Bills has moved", footer: _jsx(ButtonGroup, { children: _jsx(Button, { small: true, primary: true, children: "Take me there" }) }), footerAlign: "right", offset: { distance: 200 }, children: _jsxs(Stack, { spacing: 1, direction: "column", children: [_jsxs(BodyText, { size: "small", children: ["Bills has a new home in Accounting. It is still the same feature you know and love except now something goes here.", _jsx(Link, { primary: true, children: "Learn More" })] }), _jsx(Checkbox, { size: "small", label: "Don\u2019t show me again" })] }) })] }));
const closeMethod = () => alert('closing');
export const modal = (args) => _jsx(FeatureModal, { ...args });
modal.args = {
    open: true,
    title: 'FleetPro Has Launched!',
    closable: true,
    onClose: closeMethod,
    scrollable: true,
    children: (_jsxs(Stack, { direction: "column", alignItems: "center", spacing: 4, children: [_jsx("img", { src: image.src, alt: image.alt, className: "p-t-4" }), _jsxs(BodyText, { size: "large", className: "ta-center", children: ["We\u2019re excited to announce that FleetPro is now live in ServiceTitan! With FleetPro, you can manage and track your company\u2019s vehicles all in one place. Add FleetPro to your existing tenant now for $100 /mo or view the", ' ', _jsx(Link, { primary: true, children: "Knowledge Base" }), " to learn more."] })] })),
    footer: (_jsxs(ButtonGroup, { children: [_jsx(Button, { onClick: closeMethod, children: "No, Thank You" }), _jsx(Button, { primary: true, onClick: closeMethod, children: "Add FleetPro Now" })] })),
};
export const toast = () => {
    return (_jsx(Frame, { children: _jsxs(Toast.Group, { children: [_jsx(FeatureToast, { title: "\u2728 This page has a new look and feel", onPrimaryActionClick: () => { }, primaryActionName: "Got it", onSecondaryActionClick: () => { }, secondaryActionName: "Revert to Old View", onClose: closeMethod, portal: false, children: _jsx(BodyText, { children: "We\u2019ve updated this page with some cool stuff...but if you don\u2019t like it you can go back to the old one for now. This can be changed later in settings." }) }), _jsx(Toast, { status: "info", title: "Ordinary toast", portal: false, children: "In progress" }), _jsx(FeatureToast, { center: true, title: "Dashboards", onPrimaryActionClick: () => { }, primaryActionName: "Learn more", onClose: closeMethod, portal: false, children: _jsxs(Stack, { direction: "column", spacing: 2, alignItems: "center", children: [_jsx("img", { src: imageDashboard.src, alt: image.alt, width: "166px", className: "p-t-1" }), _jsx(BodyText, { children: "We noticed you don\u2019t really use this thing, but did you know it could increase your profit margins by 10%?" })] }) }), _jsx(FeatureToast, { center: true, title: "Slightly longer line that wraps to a second", onPrimaryActionClick: () => { }, primaryActionName: "Learn More", onClose: closeMethod, portal: false, children: _jsxs(Stack, { direction: "column", spacing: 2, alignItems: "center", children: [_jsx("img", { src: imageDashboard.src, alt: image.alt, width: "166px", className: "p-t-1" }), _jsx(BodyText, { children: "We noticed you don\u2019t really use this thing, but did you know it could increase your profit margins by 10%?" })] }) })] }) }));
};
const InternalTourControls = memo(({ children, headerText }) => {
    const { setCurrentStep, currentStep, steps, setIsOpen } = useTour();
    const handleClose = useCallback(() => {
        setIsOpen(false);
    }, [setIsOpen]);
    const handleNext = useCallback(() => {
        if (currentStep === steps.length - 1) {
            handleClose();
        }
        else {
            setCurrentStep(currentStep + 1);
        }
    }, [currentStep, handleClose, setCurrentStep, steps.length]);
    return (_jsx(TourPopover, { currentStep: currentStep, onClose: handleClose, onNext: handleNext, totalStepCount: steps.length, headerText: headerText, children: children }));
});
const ReactTour = ({ children }) => {
    const steps = [
        {
            selector: '.step-1',
            content: (_jsxs(InternalTourControls, { headerText: "\u26A0\uFE0F This is now a required field", children: [_jsx(BodyText, { size: "small", className: "m-b-2", children: "You must now select a date range beforehand because of reasons." }), _jsx(BodyText, { size: "small", children: _jsx(Link, { primary: true, children: "Learn More" }) })] })),
        },
        {
            selector: '.step-2',
            content: _jsx(InternalTourControls, { headerText: "Give it up for step 2" }),
        },
        {
            selector: '.step-3',
            content: (_jsx(InternalTourControls, { children: "This is the final step with just body text." })),
        },
    ];
    const styles = {
        popover: (base) => ({
            ...base,
            borderRadius: '6px',
            padding: 'inherit',
            margin: 'inherit',
            maxWidth: 'inherit',
        }),
    };
    return (_jsx(TourProvider, { defaultOpen: true, steps: steps, showBadge: false, showPrevNextButtons: false, showCloseButton: false, showNavigation: false, showDots: false, styles: styles, children: children }));
};
const StartTourButton = () => {
    const { setIsOpen, setCurrentStep } = useTour();
    const handleTourClick = useCallback(() => {
        setCurrentStep(0);
        setIsOpen(true);
    }, [setCurrentStep, setIsOpen]);
    return _jsx(Button, { onClick: handleTourClick, children: "Start Tour" });
};
export const tour = () => {
    return (_jsx(Frame, { children: _jsx(ReactTour, { children: _jsx(Page, { header: _jsxs(Stack, { justifyContent: "space-between", alignItems: "center", children: [_jsx(Headline, { size: "large", className: "step-3", children: "Page Title" }), _jsx(StartTourButton, {})] }), children: _jsxs(Layout, { type: "3Col", children: [_jsx(Layout.Section, { children: _jsx(Card, { className: "step-1", children: "Card 1" }) }), _jsx(Layout.Section, { children: _jsx(Card, { className: "step-2", children: "Card 2" }) }), _jsx(Layout.Section, { children: _jsx(Card, { children: "Card 3" }) })] }) }) }) }));
};
//# sourceMappingURL=feature-spotlight.stories.js.map